--Ryan Hoskin  Lab: W 2-5
--Siraj Husain Lab: W 2-5

--ALU component
--INPUTS: input_a, input_b, op
--OUTPUTS: zero, result

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all; 
use IEEE.std_logic_unsigned.all;

--Entity for ALU structure
entity ALU is
    port(
        --Incoming circuits
	input_a    : in std_logic_vector( 31 downto 0);
	input_b    : in std_logic_vector( 31 downto 0 );
	op         : in std_logic_vector( 2 downto 0 );	

        --Outgoing circuits
        zero       : out std_logic;
	result     : out std_logic_vector( 31 downto 0 )
	);
end ALU;

--Architecture design for ALU structure
architecture bhv of ALU is
begin
    process( input_a, input_b, op ) 
	variable tmp_result : std_logic_vector( 31 downto 0 );

        --Define OP codes for ALU
        constant AND_OP : STD_LOGIC_VECTOR(2 downto 0) := "000";
        constant OR_OP  : STD_LOGIC_VECTOR(2 downto 0) := "001";
        constant ADD_OP : STD_LOGIC_VECTOR(2 downto 0) := "010";
        constant SUB_OP : STD_LOGIC_VECTOR(2 downto 0) := "110";
        constant LT_OP  : STD_LOGIC_VECTOR(2 downto 0) := "111";
        
        --Perform operations requested by OP code.
    begin	
	case op is
	    when AND_OP => tmp_result := input_a and input_b;
	    when OR_OP  => tmp_result := input_b or input_a;
        when ADD_OP => tmp_result := input_a + input_b;
	    when SUB_OP => tmp_result := input_a - input_b;		
	    when LT_OP  => 		 
		
			if ( input_a < input_b ) then
		    	tmp_result := "11111111111111111111111111111111";
			else
			    tmp_result := "00000000000000000000000000000000";
			end if;	
	
	    when others => tmp_result := "00000000000000000000000000000000";
	end case;				   
		
--	if( tmp_result = "00000000000000000000000000000000" ) then
--	    zero <= '1';
--	else
--	    zero <= '0';
--	end if;
        
        --Set 'zero' output to 1 if result is 0.
        case tmp_result is
          when "00000000000000000000000000000000" => zero <= '1';
          when others => zero <= '0';
        end case;
        
	result <= tmp_result;
	
    end process;
end bhv;
