-------------------------------------------------
-- VHDL code for 2:1 multiplexor
-- (ESD book figure 2.5)
-- by Weijun Zhang, 04/2001
--
-- Multiplexor is a device to select different
-- inputs to outputs. we use 32 bits vector to 
-- describe its I/O ports 
-------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

-------------------------------------------------

entity Mux25 is
port(										
	I0: 	in std_logic_vector(4 downto 0);
	I1: 	in std_logic_vector(4 downto 0);
	S:	in std_logic; 						--select signal
	O:	out std_logic_vector(4 downto 0) 	--output signal
);
end Mux25;  

-------------------------------------------------

architecture behv1 of Mux25 is
begin
    process(I1,I0,S)
    begin
		
		if (S = '0') then
			O <= I0;
		else
			O <= I1;
		end if;
		
    end process;
end behv1;

--------------------------------------------------