-------------------------------------------------
-- VHDL code for 3:1 multiplexor
-- (ESD book figure 2.5)
-- by Weijun Zhang, 04/2001
--
-- Multiplexor is a device to select different
-- inputs to outputs. we use 32 bits vector to 
-- describe its I/O ports 
-------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

-------------------------------------------------

entity Mux3 is
port(										  
	I0: 	in std_logic_vector(31 downto 0);
	I1: 	in std_logic_vector(31 downto 0);
	I2: 	in std_logic_vector(31 downto 0);
	S:	in std_logic_vector(1 downto 0); --select signal
	O:	out std_logic_vector(31 downto 0) --output signal
);
end Mux3;  

-------------------------------------------------

architecture behv1 of Mux3 is
begin
    process(I2,I1,I0,S)
    begin
    
        -- use case statement
        case S is
	    when "00" =>	O <= I0;
	    when "01" =>	O <= I1;
	    when "10" =>	O <= I2;
	    when others =>	O <= (others => 'Z');
	end case;

    end process;
end behv1;

--------------------------------------------------


