library IEEE;
use IEEE.std_logic_1164.all; 
use IEEE.std_logic_arith.all;


entity register_ld is
  port(
      rst   : in std_logic;
      clk   : in std_logic;
      ld  : in std_logic;
      i	    : in std_logic_vector (31 downto 0);
      o     : out std_logic_vector (31 downto 0)
      );
end register_ld;

architecture behavior of register_ld is
begin
    process ( rst, clk )
    begin
	if (rst = '1') then 			--resets the register
	    o <= "00000000000000000000000000000000";
	elsif(clk'event and clk = '1') then 	--on clock event
	    if ld = '1' then 			--if load, then read in new value
		o <= i;				--copy input to output
	    end if;
	end if;
    end process;
end behavior;
