library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity reg_file is
    port ( 
	rst         : in std_logic;
	clk         : in std_logic;
	rw   : std_logic;
	rr1  : in std_logic_vector(4 downto 0);
	rr2  : in std_logic_vector(4 downto 0);
	wrr   : in std_logic_vector(4 downto 0);
	wrd  : in std_logic_vector(31 downto 0);
	rd1 : out std_logic_vector(31 downto 0);
	rd2 : out std_logic_vector(31 downto 0)
	);		
end reg_file;

architecture behavior of reg_file is

    type REG_TYPE is array (0 to 31) of std_logic_vector (31 downto 0);
    signal rf : REG_TYPE;
begin
    process ( clk, rst )
    begin			 
	if (rst = '1') then
		for i in 0 to 31 loop
			rf(i) <= "00000000000000000000000000000000";
		end loop;
	elsif(clk'event and clk = '1')then
	    if (rw = '1') then
              if( wrr /= "00000") then
                rf(conv_integer(wrr)) <= wrd;
              end if;
	    end if;
	end if;
    end process;

    process (rst, rr1, rf)
    begin
	  if (rst = '1') then
		  rd1 <= "00000000000000000000000000000000";
      elsif (rr1 = "00000") then
        rd1 <= "00000000000000000000000000000000";
      else
        rd1 <= rf(conv_integer(rr1));
      end if;
      
    end process;

    process (rst, rr2, rf)
    begin
	  if (rst = '1') then
		  rd2 <= "00000000000000000000000000000000";
      elsif (rr2 = "00000") then
        rd2 <= "00000000000000000000000000000000";
      else
        rd2 <= rf(conv_integer(rr2));
      end if;
      
    end process;
end behavior;




